VERSION 5.00
Begin VB.UserControl DualList 
   ClientHeight    =   3810
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   6420
   ScaleHeight     =   3810
   ScaleWidth      =   6420
   Begin VB.CommandButton cmdMove 
      Caption         =   "Command1"
      Height          =   435
      Index           =   3
      Left            =   2400
      TabIndex        =   4
      Top             =   1560
      Width           =   1305
   End
   Begin VB.CommandButton cmdMove 
      Caption         =   "Command1"
      Height          =   435
      Index           =   2
      Left            =   2400
      TabIndex        =   3
      Top             =   1080
      Width           =   1305
   End
   Begin VB.CommandButton cmdMove 
      Caption         =   "Command1"
      Height          =   435
      Index           =   1
      Left            =   2400
      TabIndex        =   2
      Top             =   600
      Width           =   1305
   End
   Begin VB.CommandButton cmdMove 
      Caption         =   "Command1"
      Height          =   435
      Index           =   0
      Left            =   2400
      TabIndex        =   1
      Top             =   120
      Width           =   1305
   End
   Begin VB.ListBox ListTwo 
      Height          =   3660
      IntegralHeight  =   0   'False
      Left            =   3900
      MultiSelect     =   2  'Extended
      TabIndex        =   5
      Top             =   60
      Width           =   2415
   End
   Begin VB.ListBox ListOne 
      Height          =   3660
      IntegralHeight  =   0   'False
      Left            =   60
      MultiSelect     =   2  'Extended
      TabIndex        =   0
      Top             =   60
      Width           =   2175
   End
End
Attribute VB_Name = "DualList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' *********************************************************************
'  Copyright 2001, Karl E. Peterson, All Rights Reserved.
'  http://www.mvps.org/vb
' *********************************************************************
'  You are free to use this code within your own applications, but you
'  are expressly forbidden from selling or otherwise distributing this
'  source code without prior written consent.
' *********************************************************************
Option Explicit

' Default values
Private Const defBackColor As Long = vb3DFace                '&H8000000F
Private Const defBackColorList As Long = vbWindowBackground  '&H80000005
Private Const defForeColor As Long = vbWindowText            '&H80000008
Private Const defForeColorList As Long = vbWindowText        '&H80000008
Private Const defEnabled As Boolean = True
Private Const defMousePointer As Long = vbDefault            '0

' Default button captions
Private Const defCmdAdd As String = "Add ->"
Private Const defCmdAddAll As String = "Add All ->"
Private Const defcmdRemoveove As String = "<- Remove"
Private Const defcmdRemoveoveAll As String = "<- Remove All"

' Command button array indices.
Public Enum MoveButtons
   cmdAdd = 0
   cmdAddAll = 1
   cmdRemove = 2
   cmdRemoveAll = 3
End Enum

' Member variables
Private m_BackColor As Long
Private m_BackColorList As Long
Private m_Caption(0 To 3) As String
Private m_DesignTime As Boolean
Private m_Enabled As Boolean
Private m_ForeColor As Long
Private m_ForeColorList As Long
Private m_FontList As StdFont
Private m_Font As StdFont
Private m_MinHeight As Long
Private m_MinWidth As Long

' **********************************************
'  Initialization / Termination
' **********************************************
Private Sub UserControl_Initialize()
   ' Stash some minimum dimensions based on
   ' button sizes
   m_MinWidth = cmdMove(0).Width * 3.5
   m_MinHeight = cmdMove(0).Height * 5
End Sub

Private Sub UserControl_Terminate()
   '
End Sub

Private Sub UserControl_InitProperties()
   ' Set default properties
   m_BackColor = defBackColor
   m_BackColorList = defBackColorList
   m_Caption(cmdAdd) = defCmdAdd
   m_Caption(cmdAddAll) = defCmdAddAll
   m_Caption(cmdRemove) = defcmdRemoveove
   m_Caption(cmdRemoveAll) = defcmdRemoveoveAll
   m_Enabled = defEnabled
   Set m_Font = Ambient.Font
   Set m_FontList = Ambient.Font
   m_ForeColor = defForeColor
   m_ForeColorList = defForeColorList
   ' Definitely design-time
   m_DesignTime = True
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
   ' Retrieve persisted properties
   m_BackColor = PropBag.ReadProperty("BackColor", defBackColor)
   m_BackColorList = PropBag.ReadProperty("BackColorList", defBackColorList)
   m_Caption(cmdAdd) = PropBag.ReadProperty("Caption" & cmdAdd, defCmdAdd)
   m_Caption(cmdAddAll) = PropBag.ReadProperty("Caption" & cmdAddAll, defCmdAddAll)
   m_Caption(cmdRemove) = PropBag.ReadProperty("Caption" & cmdRemove, defcmdRemoveove)
   m_Caption(cmdRemoveAll) = PropBag.ReadProperty("Caption" & cmdRemoveAll, defcmdRemoveoveAll)
   m_Enabled = PropBag.ReadProperty("Enabled", defEnabled)
   Set m_Font = PropBag.ReadProperty("Font", Ambient.Font)
   Set m_FontList = PropBag.ReadProperty("FontList", Ambient.Font)
   m_ForeColor = PropBag.ReadProperty("ForeColor", defForeColor)
   m_ForeColorList = PropBag.ReadProperty("ForeColorList", defForeColorList)
   ' Determine if design-time
   m_DesignTime = IsDesignTime()
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
   ' Persist properties
   Call PropBag.WriteProperty("BackColor", m_BackColor, defBackColor)
   Call PropBag.WriteProperty("BackColorList", m_BackColorList, defBackColorList)
   Call PropBag.WriteProperty("Caption" & cmdAdd, m_Caption(cmdAdd), defCmdAdd)
   Call PropBag.WriteProperty("Caption" & cmdAddAll, m_Caption(cmdAddAll), defCmdAddAll)
   Call PropBag.WriteProperty("Caption" & cmdRemove, m_Caption(cmdRemove), defcmdRemoveove)
   Call PropBag.WriteProperty("Caption" & cmdRemoveAll, m_Caption(cmdRemoveAll), defcmdRemoveoveAll)
   Call PropBag.WriteProperty("Enabled", m_Enabled, defEnabled)
   Call PropBag.WriteProperty("Font", m_Font, Ambient.Font)
   Call PropBag.WriteProperty("FontList", m_FontList, Ambient.Font)
   Call PropBag.WriteProperty("ForeColor", m_ForeColor, defForeColor)
   Call PropBag.WriteProperty("ForeColorList", m_ForeColorList, defForeColorList)
End Sub

' **********************************************
'  Persisted Properties
' **********************************************
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
   BackColor = m_BackColor
End Property

Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
   m_BackColor = NewVal
   Call SetColors
   PropertyChanged "BackColor"
End Property

Public Property Get BackColorList() As OLE_COLOR
Attribute BackColorList.VB_Description = "Returns/sets the background color used to display text in the listboxes."
Attribute BackColorList.VB_ProcData.VB_Invoke_Property = ";Appearance"
   BackColorList = m_BackColorList
End Property

Public Property Let BackColorList(ByVal NewVal As OLE_COLOR)
   m_BackColorList = NewVal
   Call SetColors
   PropertyChanged "BackColorList"
End Property

Public Property Get Caption(ByVal Which As MoveButtons) As String
Attribute Caption.VB_Description = "Returns/sets the text displayed on the command buttons."
   If Which >= cmdAdd And Which <= cmdRemoveAll Then
      Caption = m_Caption(Which)
   End If
End Property

Public Property Let Caption(ByVal Which As MoveButtons, ByVal NewVal As String)
   If Which >= cmdAdd And Which <= cmdRemoveAll Then
      m_Caption(Which) = NewVal
      Call SetCaptions
      PropertyChanged "Caption" & Which
   End If
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
   Enabled = ListOne.Enabled
End Property

Public Property Let Enabled(ByVal NewVal As Boolean)
   m_Enabled = NewVal
   Call SetEnabled
   PropertyChanged "Enabled"
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
   ForeColor = m_ForeColor
End Property

Public Property Let ForeColor(ByVal NewVal As OLE_COLOR)
   m_ForeColor = NewVal
   Call SetColors
   PropertyChanged "ForeColor"
End Property

Public Property Get ForeColorList() As OLE_COLOR
Attribute ForeColorList.VB_Description = "Returns/sets the foreground color used to display text and graphics in the listboxes."
Attribute ForeColorList.VB_ProcData.VB_Invoke_Property = ";Appearance"
   ForeColorList = m_ForeColorList
End Property

Public Property Let ForeColorList(ByVal NewVal As OLE_COLOR)
   m_ForeColorList = NewVal
   Call SetColors
   PropertyChanged "ForeColor"
End Property

Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns/sets the font object assigned to the command buttons."
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
   Set Font = m_Font
End Property

Public Property Set Font(ByVal NewVal As Font)
   Set m_Font = NewVal
   Call SetFonts
   PropertyChanged "Font"
End Property

Public Property Get FontList() As Font
Attribute FontList.VB_Description = "Returns/sets the font object assigned to the listboxes."
Attribute FontList.VB_ProcData.VB_Invoke_Property = ";Font"
   Set FontList = m_FontList
End Property

Public Property Set FontList(ByVal NewVal As Font)
   Set m_FontList = NewVal
   Call SetFonts
   PropertyChanged "FontList"
End Property

' **********************************************
'  Non-Persisted Properties
' **********************************************
Public Property Get List1() As Object
Attribute List1.VB_Description = "Returns the first of two contained listboxes."
Attribute List1.VB_ProcData.VB_Invoke_Property = ";Misc"
   Set List1 = ListOne
End Property

Public Property Get List2() As Object
Attribute List2.VB_Description = "Returns the second of two contained listboxes."
Attribute List2.VB_ProcData.VB_Invoke_Property = ";Misc"
   Set List2 = ListTwo
End Property

' **********************************************
'  Methods
' **********************************************

' **********************************************
'  Mapped Events
' **********************************************
Private Sub cmdMove_Click(Index As Integer)
   Select Case Index
      Case cmdAdd
         ' Move each selected item from ListOne to ListTwo
         Call MoveItems(ListOne, ListTwo, False)
      Case cmdAddAll
         ' Move all items from ListOne to ListTwo
         Call MoveItems(ListOne, ListTwo, True)
      Case cmdRemove
         ' Move each selected item from ListTwo to ListOne
         Call MoveItems(ListTwo, ListOne, False)
      Case cmdRemoveAll
         ' Move all items from ListTwo to ListOne
         Call MoveItems(ListTwo, ListOne, True)
   End Select
   Call SetButtonEnabled
End Sub

Private Sub ListOne_Click()
   Call SetButtonEnabled
End Sub

Private Sub ListTwo_Click()
   Call SetButtonEnabled
End Sub

' **********************************************
'  Non-Mapped Events
' **********************************************
Private Sub UserControl_AmbientChanged(PropertyName As String)
   On Error Resume Next
   Select Case PropertyName
      Case "DisplayName"
         Call UpdateDisplayName
      Case Else
         Debug.Print PropertyName
   End Select
End Sub

Private Sub UserControl_Resize()
   Dim i As Long
   Dim lWidth As Long
   Const nBtnOffset As Long = 60
   
   ' "Errors Happen" in resizing code <sigh>
   On Error Resume Next
   
   ' Make sure we're not smaller than allowed
   If UserControl.Width < m_MinWidth Then
      UserControl.Width = m_MinWidth
      Exit Sub
   End If
   If UserControl.Height < m_MinHeight Then
      UserControl.Height = m_MinHeight
      Exit Sub
   End If

   ' Calc width of each list
   lWidth = (UserControl.Width - cmdMove(0).Width - (nBtnOffset * 6)) \ 2
   
   ' Position lists on either side of UC
   With UserControl
      ListOne.Move 0, 0, lWidth, .Height
      ListTwo.Move .Width - lWidth, 0, lWidth, .Height
   End With
   
   ' Position first command button
   cmdMove(0).Left = (UserControl.Width \ 2) - cmdMove(0).Width \ 2
   cmdMove(0).Top = nBtnOffset * 2
   
   ' Position buttons 1 thru 3
   For i = 1 To 3
      cmdMove(i).Move cmdMove(0).Left, cmdMove(i - 1).Top + cmdMove(i - 1).Height + nBtnOffset
   Next i
End Sub

Private Sub UserControl_Show()
   ' Set all control properties
   Call SetCaptions
   Call SetFonts
   Call SetColors
   Call SetButtonEnabled
   Call UpdateDisplayName
End Sub

' **********************************************
'  Private Methods
' **********************************************
Private Function IsDesignTime() As Boolean
   On Error GoTo AmbientNotSupported
   If Ambient.UserMode = True Then
      ' The control is currently being used by a form user.
      ' If the container does not implement this ambient
      ' property, this will be the default value. In Visual
      ' Basic, this is Run Mode.
      IsDesignTime = False
   Else
      ' The control is currently being used by a form designer
      ' (the developer). In Visual Basic, this is Design Mode.
      IsDesignTime = True
   End If
   Exit Function
AmbientNotSupported:
   ' Default or not, can't be too careful!
   IsDesignTime = False
End Function

Private Sub MoveItems(lstFrom As ListBox, lstTo As ListBox, Optional MoveAll As Boolean = False)
   Dim i As Long
   
   With lstFrom
      If MoveAll Then
         ' Move every item from one list to the other
         Do While .ListCount
            lstTo.AddItem .List(0)
            lstTo.ItemData(lstTo.NewIndex) = .ItemData(0)
            .RemoveItem 0
         Loop
      Else
         ' Copy all selected items, then delete
         For i = 0 To .ListCount - 1
            If .Selected(i) Then
               lstTo.AddItem .List(i)
               lstTo.ItemData(lstTo.NewIndex) = .ItemData(i)
            End If
         Next i
         For i = .ListCount - 1 To 0 Step -1
            If .Selected(i) Then
               .RemoveItem i
            End If
         Next i
      End If
   End With
End Sub

Private Sub SetButtonEnabled()
   If m_Enabled Then
      If Not m_DesignTime Then
         ' Add should only be enabled if at least one
         ' element of ListOne is selected
         cmdMove(cmdAdd).Enabled = (ListOne.SelCount > 0)
         ' AddAll should only be enabled if there are
         ' elements still in ListOne
         cmdMove(cmdAddAll).Enabled = (ListOne.ListCount > 0)
         ' Remove should only be enabled if at least one
         ' element of ListTwo is selected
         cmdMove(cmdRemove).Enabled = (ListTwo.SelCount > 0)
         ' AddAll should only be enabled if there are
         ' elements still in ListTwo
         cmdMove(cmdRemoveAll).Enabled = (ListTwo.ListCount > 0)
      Else
         ' Enable all to allow easy viewing at
         ' design time
         cmdMove(cmdAdd).Enabled = True
         cmdMove(cmdAddAll).Enabled = True
         cmdMove(cmdRemove).Enabled = True
         cmdMove(cmdRemoveAll).Enabled = True
      End If
   Else
      ' If control is disabled, so should all buttons be
      cmdMove(cmdAdd).Enabled = False
      cmdMove(cmdAddAll).Enabled = False
      cmdMove(cmdRemove).Enabled = False
      cmdMove(cmdRemoveAll).Enabled = False
   End If
End Sub

Private Sub SetCaptions()
   Dim i As Long
   ' Assign button captions
   For i = cmdAdd To cmdRemoveAll
      cmdMove(i).Caption = m_Caption(i)
   Next i
End Sub

Private Sub SetColors()
   Dim i As Long
   ' set colors for all controls
   UserControl.BackColor = m_BackColor
   UserControl.ForeColor = m_ForeColor
   ListOne.BackColor = m_BackColorList
   ListOne.ForeColor = m_ForeColorList
   ListTwo.BackColor = m_BackColorList
   ListTwo.ForeColor = m_ForeColorList
   For i = cmdAdd To cmdRemoveAll
      cmdMove(i).BackColor = m_BackColor
   Next i
End Sub

Private Sub SetEnabled()
   ' Set all controls appropriately
   UserControl.Enabled = m_Enabled
   ListOne.Enabled = m_Enabled
   ListTwo.Enabled = m_Enabled
   Call SetButtonEnabled
End Sub

Private Sub SetFonts()
   ' Set fonts for all controls
   Set ListOne.Font = m_FontList
   Set ListTwo.Font = m_FontList
   Set cmdMove(cmdAdd).Font = m_Font
   Set cmdMove(cmdAddAll).Font = m_Font
   Set cmdMove(cmdRemove).Font = m_Font
   Set cmdMove(cmdRemoveAll).Font = m_Font
End Sub

Private Sub UpdateDisplayName()
   ' Add dummy items to lists, if in IDE
   If m_DesignTime Then
      On Error Resume Next
      ListOne.List(0) = Extender.Name & ".List1"
      ListTwo.List(0) = Extender.Name & ".List2"
   End If
End Sub

